import React, {Component} from 'react'
import PropTypes from 'prop-types'
import { is, fromJS } from 'immutable'
import { Spin, Button } from 'antd'

import Api from '@/api'
import UtilsDM from '@/utils/utils-datamanage.js'
import asyncComponent from '@/utils/asyncComponent'
import asyncSpinComponent from '@/utils/asyncSpinComponent'
import MKEmitter from '@/utils/events.js'
import './index.scss'

const MutilForm = asyncSpinComponent(() => import('@/tabviews/zshare/mutilform'))
const NormalButton = asyncComponent(() => import('@/tabviews/zshare/actionList/normalbutton'))

class StepForm extends Component {
  static propTpyes = {
    config: PropTypes.object
  }

  state = {
    BID: '',
    config: null,
    loading: false,
    data: null,
    group: null,
    BData: '',
    step: 0
  }

  UNSAFE_componentWillMount () {
    const { config } = this.props

    let _config = fromJS(config).toJS()
    let _data = null
    let BID = ''
    let BData = ''

    if (_config.setting.supModule) {
      BData = window.GLOB.CacheData.get(_config.setting.supModule)
    } else {
      BData = window.GLOB.CacheData.get(_config.$pageId)
    }
    if (BData) {
      BID = BData.$BID || ''
    }

    if (_config.wrap.datatype === 'dynamic') {
      _config.setting.onload = _config.setting.sync === 'true' ? 'false' : 'true'

      if (_config.setting.sync === 'true' && window.GLOB.SyncData.has(_config.dataName)) {
        _data = window.GLOB.SyncData.get(_config.dataName) || []
        _data = _data[0] || {$$empty: true}
        _data.$$uuid = _data[_config.setting.primaryKey] || ''

        _config.setting.sync = 'false'
  
        window.GLOB.SyncData.delete(_config.dataName)
      }
    } else if (_config.wrap.datatype === 'public') {
      if (window.GLOB.CacheData.has(_config.wrap.publicId)) {
        _data = window.GLOB.CacheData.get(_config.wrap.publicId)
        _data = fromJS(_data).toJS()
        _data.$$BID = BID || ''
        _data.$$BData = BData || ''
      }
    } else {
      _data = {$$empty: true}
    }

    if (!_config.wrap.groupLabel) {
      if (_config.subcards.length > 1) {
        _config.wrap.groupLabel = 'show'
      } else {
        _config.wrap.groupLabel = 'hidden'
      }
    }

    _config.subcards = _config.subcards.map((group, i) => {
      group.sort = i + 1
      if (i === 0 && group.prevButton.actionType !== 'close') {
        group.prevButton.enable = 'false'
      }
      if (i + 1 === _config.subcards.length && group.nextButton.actionType !== 'close') {
        group.nextButton.enable = 'false'
      }

      if (group.subButton.enable === 'false') {
        group.subButton.style.display = 'none'
      }

      if (group.prevButton.enable === 'false' && group.subButton.enable === 'false' && group.nextButton.enable === 'false') {
        group.$button = 'no-button'
      }

      return group
    })

    let _group = _config.subcards[0]

    if (_data && _config.wrap.statusControl && _data[_config.wrap.statusControl] !== undefined) {
      let _status = _data[_config.wrap.statusControl] + ''

      let _groups = _config.subcards.filter(item => item.setting.status === _status)[0]
      _group = _groups || _group
    }

    _config.titleStyle = {}
    _config.sortStyle = {}

    if (_config.style.fontSize) {
      let size = parseInt(_config.style.fontSize)
      _config.titleStyle = {fontSize: size}
      let s = size * 1.5 + 'px'
      _config.sortStyle = {width: s, height: s, lineHeight: s, borderRadius: s}
    }

    _config.style['--mk-active-color'] = _config.wrap.color || '#1890ff'

    this.setState({
      data: _data,
      group: _group,
      step: _group.sort - 1,
      BID: BID || '',
      BData: BData || '',
      config: _config
    })
  }

  componentDidMount () {
    const { config } = this.state

    MKEmitter.addListener('reloadData', this.reloadData)
    MKEmitter.addListener('mkFormSubmit', this.mkFormSubmit)
    MKEmitter.addListener('resetSelectLine', this.resetParentParam)
    MKEmitter.addListener('queryModuleParam', this.queryModuleParam)
    MKEmitter.addListener('refreshByButtonResult', this.refreshByButtonResult)

    if (config.setting.sync === 'true') {
      MKEmitter.addListener('transferSyncData', this.transferSyncData)
    }

    if (config.wrap.datatype === 'public') {
      MKEmitter.addListener('mkPublicData', this.mkPublicData)
    } else if (config.setting.useMSearch) {
      MKEmitter.addListener('searchRefresh', this.searchRefresh)
    }

    this.initExec()
  }

  shouldComponentUpdate (nextProps, nextState) {
    return !is(fromJS(this.state), fromJS(nextState))
  }

  componentWillUnmount () {
    this.setState = () => {
      return
    }
    MKEmitter.removeListener('reloadData', this.reloadData)
    MKEmitter.removeListener('mkPublicData', this.mkPublicData)
    MKEmitter.removeListener('mkFormSubmit', this.mkFormSubmit)
    MKEmitter.removeListener('searchRefresh', this.searchRefresh)
    MKEmitter.removeListener('resetSelectLine', this.resetParentParam)
    MKEmitter.removeListener('transferSyncData', this.transferSyncData)
    MKEmitter.removeListener('queryModuleParam', this.queryModuleParam)
    MKEmitter.removeListener('refreshByButtonResult', this.refreshByButtonResult)
  }

  initExec = () => {
    const { config } = this.state
    
    if (config.wrap.datatype === 'dynamic' && config.setting.onload === 'true') {
      setTimeout(() => {
        this.loadData()
      }, config.setting.delay || 0)
    }
  }

  transferSyncData = (syncId) => {
    const { config, group } = this.state

    if (config.$syncId !== syncId) return

    let _data = window.GLOB.SyncData.get(config.dataName) || []
    _data = _data[0] || {$$empty: true}
    _data.$$uuid = _data[config.setting.primaryKey] || ''

    let _group = group

    if (config.wrap.statusControl && _data[config.wrap.statusControl] !== undefined) {
      let _status = _data[config.wrap.statusControl] + ''
      let _groups = config.subcards.filter(item => item.setting.status === _status)[0]
      _group = _groups || _group
    }

    this.setState({data: _data, group: _group, step: _group.sort - 1})

    window.GLOB.SyncData.delete(config.dataName)

    MKEmitter.removeListener('transferSyncData', this.transferSyncData)
  }

  mkPublicData = (publicId, data) => {
    const { config, BID, BData } = this.state

    if (config.wrap.datatype === 'public' && config.wrap.publicId === publicId) {
      let _data = fromJS(data).toJS()

      _data.$$BID = BID || ''
      _data.$$BData = BData || ''

      this.setState({
        data: null
      }, () => {
        this.setState({data: _data})
      })
    }
  }

  searchRefresh = (searchId) => {
    const { config } = this.state

    if (config.$searchId !== searchId) return
    
    this.setState({}, () => {
      this.loadData()
    })
  }

  /**
   * @description 获取组件搜索
   */
  queryModuleParam = (menuId, callback) => {
    const { config } = this.state

    if (config.uuid !== menuId) return

    let searches = []
    if (config.setting.useMSearch) { // 主表搜索条件
      searches = window.GLOB.SearchBox.get(config.$searchId) || []
    }

    callback({
      search: searches
    })
  }

  reloadData = (menuId, id) => {
    const { config } = this.state

    if (config.uuid !== menuId) return

    this.loadData('refresh')
  }

  /**
   * @description 按钮执行完成后页面刷新
   * @param {*} menuId     // 菜单Id
   * @param {*} position   // 刷新位置
   * @param {*} btn        // 执行的按钮
   */
  refreshByButtonResult = (menuId, position, btn, id) => {
    const { config, BID } = this.state

    if (config.uuid !== menuId) return

    if ((position === 'mainline' || position === 'popclose') && config.setting.supModule && BID) {
      MKEmitter.emit('reloadData', config.setting.supModule, BID)
    } else if (position === 'grid' && config.wrap.datatype === 'static') {
      this.setState({
        data: null
      }, () => {
        this.setState({data: {$$empty: true}})
      })
    } else {
      this.loadData()
    }

    if (id) {
      MKEmitter.emit('resetSelectLine', config.uuid, id, '')
    }

    this.execSuccess(btn, id)
  }

  resetParentParam = (MenuID, id, data) => {
    const { config } = this.state

    if (!config.setting.supModule || config.setting.supModule !== MenuID) return
    
    if (id !== this.state.BID || id !== '') {
      if (config.wrap.datatype === 'static' || (config.setting.supModule && !id)) {
        this.setState({
          data: null,
          BID: id,
          BData: data
        }, () => {
          this.setState({
            data: {$$empty: true}
          })
        })
      } else {
        this.setState({ BID: id, BData: data }, () => {
          this.loadData()
        })
      }
    }
  }

  execSuccess = (btn, id) => {
    const { config, group } = this.state

    if (config.subcards.length > group.sort) {
      let _group = config.subcards.filter(item => item.sort === (group.sort + 1))[0]
  
      this.setState({group: null, step: group.sort}, () => {
        this.setState({group: _group})
      })
    } else {
      this.setState({step: group.sort})
    }

    if (btn.linkmenu && btn.linkmenu.length > 0) {
      let menu_id = btn.linkmenu[btn.linkmenu.length - 1]
      let menu = window.GLOB.mkThdMenus.get(menu_id) || ''

      if (!menu) return

      let newtab = {
        ...menu,
        param: {$BID: id || ''}
      }

      MKEmitter.emit('modifyTabs', newtab, true)
    }
  }

  async loadData (type) {
    const { config, BID } = this.state

    if (config.wrap.datatype === 'public') {
      MKEmitter.emit('reloadData', config.wrap.publicId)
      return
    } else if (config.wrap.datatype === 'static') {
      this.setState({
        data: {$$empty: true}
      })
      return
    } else if (config.setting.supModule && !BID) {
      this.setState({
        data: null
      }, () => {
        this.setState({data: {$$empty: true}})
      })
      MKEmitter.emit('resetSelectLine', config.uuid, '', '')
      return
    }

    let searches = []
    if (config.setting.useMSearch) { // 主表搜索条件
      searches = window.GLOB.SearchBox.get(config.$searchId) || []
    }

    if (config.$s_req && searches.filter(item => item.required && item.value === '').length > 0) {
      return
    }

    this.setState({
      loading: true
    })

    let _orderBy = config.setting.order || ''
    let param = UtilsDM.getQueryDataParams(config.setting, searches, _orderBy, 1, 1, BID)

    let result = await Api.genericInterface(param)
    if (result.status) {
      let _data = result.data && result.data[0] ? result.data[0] : {$$empty: true}
      let _group = this.state.group

      _data.$$uuid = _data[config.setting.primaryKey] || ''

      if (type === 'refresh') {
        _group = config.subcards[0]
      }

      if (config.wrap.statusControl && _data[config.wrap.statusControl] !== undefined) {
        let _status = _data[config.wrap.statusControl] + ''
        let _groups = config.subcards.filter(item => item.setting.status === _status)[0]
        _group = _groups || _group
      }

      let step = this.state.step

      if (config.subcards.length !== _group.sort || config.subcards.length !== step) {
        step = _group.sort - 1
      }

      this.setState({
        group: null,
        step: step,
        data: _data,
        loading: false
      }, () => {
        this.setState({group: _group})
      })

      MKEmitter.emit('resetSelectLine', config.uuid, _data.$$uuid, _data)

      UtilsDM.querySuccess(result)
    } else {
      this.setState({
        loading: false,
      })
      
      UtilsDM.queryFail(result)
    }
  }

  mkFormSubmit = (btnId, callback) => {
    const { group } = this.state

    if (group.uuid !== btnId) return

    this.formRef.handleConfirm().then(res => {
      MKEmitter.emit('triggerFormSubmit', {menuId: btnId, form: res})
    }, () => {
      callback && callback()
    })
  }

  prevStep = () => {
    const { config, group } = this.state

    if (group.prevButton.actionType === 'close') {
      MKEmitter.emit('closeTabView', group.subButton.$MenuID)
      return
    }

    let _group = config.subcards.filter(item => item.sort === (group.sort - 1))[0]

    this.setState({group: null, step: group.sort - 2}, () => {
      this.setState({group: _group})
    })
  }

  nextStep = () => {
    const { config, group } = this.state

    if (group.nextButton.actionType === 'close') {
      MKEmitter.emit('closeTabView', group.subButton.$MenuID)
      return
    }

    let _group = config.subcards.filter(item => item.sort === (group.sort + 1))[0]

    this.setState({group: null, step: group.sort}, () => {
      this.setState({group: _group})
    })
  }

  changeGroup = (sort) => {
    const { config, step } = this.state

    if (config.wrap.labelJump !== 'true' || sort > step) return

    let _group = config.subcards.filter(item => item.sort === sort)[0]

    this.setState({group: null, step: sort - 1}, () => {
      this.setState({group: _group})
    })
  }

  render() {
    const { config, loading, BID, BData, data, group, step } = this.state

    if (config.wrap.empty === 'hidden' && (!data || data.$$empty)) return null
    if (config.idCtrl && (!data || data.$$empty)) return null
    
    return (
      <div className="custom-normal-form-box" id={'anchor' + config.uuid} style={{...config.style}}>
        {loading ?
          <div className="loading-mask">
            <div className="ant-spin-blur"></div>
            <Spin />
          </div> : null
        }
        {config.wrap.groupLabel !== 'hidden' ? <div className={'mk-normal-form-title' + (config.wrap.labelJump === 'true' ? ' jumpable' : '')}>
          {config.subcards.map(card => (
            <div key={card.uuid} style={config.titleStyle} className={'form-title' + (card.sort <= step ? ' active' : '')}>
              <span className="form-sort" onClick={() => this.changeGroup(card.sort)} style={config.sortStyle}>{card.sort}</span>
              <br/>
              <span className="form-label" onClick={() => this.changeGroup(card.sort)}>{card.setting.title}</span>
              <span className="before-line"></span>
              <span className="after-line"></span>
            </div>))
          }
        </div> : null}
        {group && data ? <MutilForm
          BID={BID}
          BData={BData}
          data={data}
          action={group}
          unload={config.setting.supModule && !BID}
          inputSubmit={() => this.mkFormSubmit(group.uuid)}
          wrappedComponentRef={(inst) => this.formRef = inst}
        /> : null}
        {group && data ? <div className={'mk-form-action ' + (group.$button || '') + (group.nextButton.enable === 'true' ? ' has-skip' : '')}>
          {group.prevButton.enable === 'true' ? <Button type="link" className="prev" onClick={this.prevStep} style={group.prevButton.style}>{group.prevButton.label}</Button> : null}
          <NormalButton
            BID={BID}
            btn={group.subButton}
            setting={config.setting}
            columns={config.columns}
            selectedData={data.$$empty ? [] : [data]}
          />
          {group.nextButton.enable === 'true' ? <Button type="link" className="skip" onClick={this.nextStep} style={group.nextButton.style}>{group.nextButton.label}</Button> : null}
        </div> : null}
      </div>
    )
  }
}

export default StepForm